VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSupplier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' clsSupplier
Option Explicit

' Ҥ Enum

Enum CompanyConstants
    Company = 1
    Partnership
End Enum

Enum ProductConstants
    Computer = 1
    Electronics
    Equipment
    Metal
    Services
    PRODUCT_MAX = Services
End Enum

' СȤسѵ Private members
Private m_CompanyName As String
Private m_CompanyType As String
Private m_ID As String
Private m_RecordDate As Date
Private m_Contact As Boolean
Private m_ProductType As String
Private m_ReverseName As Variant
Private m_Notes(1 To 10) As String
Private m_OfficeAddress As clsAddress
Private m_FactoryAddress As clsAddress
Private m_WarehouseAddress As clsAddress
Private m_CurrentAddress As Variant

Private Sub Class_Initialize()
    m_Contact = True
End Sub

' ʹ constructor
Friend Sub Init(CompanyName As String, CompanyType As CompanyConstants, Optional ID As String, Optional RecordDate As Variant)
    Me.CompanyName = CompanyName
    Me.CompanyType = CompanyType
    Me.ID = ID
    Me.RecordDate = RecordDate
End Sub

' سѵ CompanyName
Property Get CompanyName() As String
    CompanyName = m_CompanyName
End Property

Property Let CompanyName(ByVal newValue As String)
    ' ԴԴҴդ˹ըԧ
    If newValue = "" Then Err.Raise 5    ' ҡͧ procedure ըԧ
    ' 纤㹵 private member
    m_CompanyName = newValue
    m_ReverseName = Empty
End Property

' سѵ CompanyType
Property Get CompanyType() As CompanyConstants
    CompanyType = m_CompanyType
End Property

Property Let CompanyType(ByVal newValue As CompanyConstants)
    ' ʸá˹ըԧ
    If newValue <> Company And newValue <> Partnership Then Err.Raise 5
    m_CompanyType = newValue
End Property

' CompanyDescr

Property Get CompanyDescr() As String
    If m_CompanyType = Company Then
        CompanyDescr = "Co Ltd."
    ElseIf m_CompanyType = Partnership Then
        CompanyDescr = "Ltd Part."
   End If
End Property

Property Let CompanyDescr(ByVal newValue As String)
    If LCase$(newValue) = "company" Then
        CompanyDescr = Company
    ElseIf LCase$(newValue) = "partnership" Then
        CompanyDescr = Partnership
    End If
End Property

' ID
Property Get ID() As String
    ID = m_ID
End Property

Property Let ID(ByVal newValue As String)
    ' ԴԴҴդ˹ըԧ
    If newValue = "" Then Err.Raise 5    ' ҡͧ procedure ըԧ
        m_ID = newValue
End Property

' Record date
Property Get RecordDate() As Date
    RecordDate = m_RecordDate
End Property

Property Let RecordDate(ByVal newValue As Date)
    If newValue >= Now Then Err.Raise 1001, , "öѹ͹Ҥ"
    m_RecordDate = newValue
End Property

' complete name
Property Get CompleteName() As String
    CompleteName = CompanyName & "  " & CompanyDescr
End Property

Property Let CompleteName(ByVal newValue As String)
    Dim items() As String
    items() = Split(newValue)
    ' Ҵ 2 ¡÷١ͧ
    If UBound(items) <> 1 Then Err.Raise 5
    ' ˹سѵѡ
    CompanyName = items(0)
    CompanyDescr = items(1)
End Property

' reversed name
Function ReverseName() As String
    If IsEmpty(m_ReverseName) Then
        m_ReverseName = CompanyDescr & ", " & CompanyName
    End If
    ReverseName = m_ReverseName
End Function

' ԴͷҧáԨ֧ջѨغѹ
Property Get Deal() As Integer
    Deal = Year(Now) - Year(RecordDate)
End Property

' سѵ Notes (array)
Property Get Notes(Optional index As Integer = 1) As String
    Notes = m_Notes(index)
End Property

Property Let Notes(Optional index As Integer = 1, ByVal newValue As String)
    ' ǨͺԴҴ subscript out of range
    If index < LBound(m_Notes) Or index > UBound(m_Notes) Then Err.Raise 9
    m_Notes(index) = newValue
End Property


' سѵ ProductType
Property Get ProductType() As ProductConstants
    ProductType = m_ProductType
End Property

Property Let ProductType(ByVal newValue As ProductConstants)
    ' ʸá˹ըԧ
    If newValue < 0 Or newValue > PROUCT_MAX Then Err.Raise 5
    m_ProductType = newValue
End Property

Property Get ProductDescr() As String
    Select Case m_ProductType
        Case Computer: ProductDescr = "Computer"
        Case Electronics: ProductDescr = "Electronics"
        Case Equipment: ProductDescr = "Equipment"
        Case Metal: ProductDescr = "Metal"
        Case Services
            If CompanyType = Company Then
                ProductDescr = "Executive Services"
            ElseIf CompanyType = Partnership Then
                ProductDescr = "General Services"
            End If
        Case Else
            Err.Raise 5       ' ͧѹ
    End Select
End Property

Property Let ProductDescr(ByVal newValue As String)
    Select Case LCase$(newValue)
        Case "computer": ProductDescr = Computer
        Case "electronics": ProductDescr = Electronics
        Case "equipment": ProductDescr = Equipment
        Case "metal": ProductDescr = Metal
        Case "Executive Services", "General Services": ProductDescr = Services
        Case Else
            Err.Raise 5       ' óչ͡ҡԴԴҴ
    End Select
End Property

' سѵ  FactoryAddress

Property Get FactoryAddress() As clsAddress
    Set FactoryAddress = m_FactoryAddress
End Property

Property Set FactoryAddress(ByVal newValue As clsAddress)
    Set m_FactoryAddress = newValue
End Property

' سѵ OfficeAddress

Property Get OfficeAddress() As clsAddress
    Set OfficeAddress = m_OfficeAddress
End Property

Property Set OfficeAddress(ByVal newValue As clsAddress)
    Set m_OfficeAddress = newValue
End Property

' سѵ  WarehouseAddress

Property Get WarehouseAddress() As clsAddress
    Set WarehouseAddress = m_WarehouseAddress
End Property

Property Set WarehouseAddress(ByVal newValue As clsAddress)
    Set m_WarehouseAddress = newValue
End Property

' سѵ  CurrentAddress
' (ҧسѵ Variant öͺਤ)

Property Get CurrentAddress() As Variant
    If IsObject(m_CurrentAddress) Then
        Set CurrentAddress = m_CurrentAddress
    Else
        CurrentAddress = m_CurrentAddress
    End If
End Property

Property Let CurrentAddress(ByVal newValue As Variant)
    If VarType(newValue) <> vbString Then Err.Raise 5
    m_CurrentAddress = newValue
End Property

Property Set CurrentAddress(ByVal newValue As clsAddress)
    ' ÷Ѵջª ͺਤա÷ͺѵѵԨҡ VB compiler
    ' If TypeName(newValue) <> "clsAddress" Then Err.Raise 5
    Set m_CurrentAddress = newValue
End Property


